var openTab = {
	'type' : [], // 8 types of tabs, further info. see expressolivre.org/dev/wiki/mail/Documentacao
	'content_id' : [],
	'imapUid' : [], // Stores the imap email number of current tab
	'countFile' : [0,0,0,0,0,0,0,0,0,0], // Stores the number of files attached in current tab
	'imapBox' : [], // Stores the folder name
	'toPreserve' : [], // Check if the message should be removed from draft after send
	'autosave_timer' : [] // The timeout timer for autosave function
};
var tabTypes = {
	'new':4,
	'forward':6,
	'reply_with_history':7,
	'reply_to_all_with_history':7,
	'reply_without_history':7,
	'reply_to_all_without_history':7,
	'edit':5
};
var currentTab,numBox = 0; // Open Tab and num of mailboxes opened at context

function setBorderAttributes(ID)
{
	this.border_id = "border_id_"+ID;
	this.sequence = ID; 
}


function alternate_border(ID)
{
	if (! Element('border_id_'+ID))
		return false; // Not possible to alternate
	show_hide_span_paging(ID);
	spanD = Element("span_D");
	if (spanD)
		spanD.style.display = (openTab.type[ID] == 0 ? '' : 'none');

	var footer_menu = Element("footer_menu");	
	if (footer_menu) {
		footer_menu.style.display = (openTab.type[ID] != 4 ? '' : 'none');
	}

	var len = BordersArray.length;
	for (var i=0; i < len; i++)
	{
		m = document.getElementById(BordersArray[i].border_id);
		if ((m)&&(m.className == 'menu-sel'))
		{
			m.className = 'menu';
			c = document.getElementById("content_id_"+BordersArray[i].sequence);
			c.style.display = 'none';
			if(Element("font_border_id_"+BordersArray[i].sequence))
				Element("font_border_id_"+BordersArray[i].sequence).className = 'font-menu';	
			var body = Element('body_'+BordersArray[i].sequence);
			if (body)
			{
				try
				{
					if (Element('viewsource_rt_checkbox').checked)
					{  
						expresso.connector.loadScript("jscode/rich_text_editor");
						RichTextEditor.viewsource(false);
					}
				}
				catch(e)
				{
					//alert(e.message)
				}
			}
		}
	}

	m = Element("border_id_"+ID);
	if (m)
		m.className = 'menu-sel';
	if(Element("font_border_id_" + ID))
		Element("font_border_id_" + ID).className = 'font-menu-sel';
	var c = Element("content_id_"+ID);
	if (c)
		c.style.display = '';

	body = document.getElementById('body_'+ ID);
	if (body){
		try{
			if(ID){
				expresso.connector.loadScript("jscode/rich_text_editor");
				RichTextEditor.loadEditor(ID);
			}
			body.contentWindow.document.designMode="on";
		}
		catch(e){
			//alert(e.message);
		};
	}

	// hide the DropDrowContact, if necessary
	window_DropDownContacts = Element('tipDiv');
	if ((window_DropDownContacts)&&(window_DropDownContacts.style.visibility != 'hidden')){
		window_DropDownContacts.style.visibility = 'hidden';
	}

	if (typeof(ID) == 'number')
	{
        numBox=ID;
 	}
	else
		if (ID.match("search_"))
			numBox=ID.substr(7);

	currentTab=ID;
	return ID;
}

function create_border(borderTitle, id_value)
{
	if ( _dragArea == null )
		_dragArea = new DragArea( );

	var resize = false;
	var offWidth = Element('border_blank').offsetWidth ? Element('border_blank').offsetWidth : Element('border_blank').clientWidth;
	if (offWidth < 200) {
		resize = resize_borders();
		if (!resize){
			alert(get_lang('Reached maximum tab limit'));
			return false;
		}
	}
	
	if (! id_value) // Is new message?
		var ID = parseInt(BordersArray[(BordersArray.length-1)].sequence) + 1;
	else
	{
                if (Element("border_id_"+id_value)) // It's opened already!
			return alternate_border(id_value);
		var ID = id_value;
		openTab.imapBox[ID] = current_folder;
	}
	td = document.createElement("TD");
	td.id="border_id_" + ID;
	if(resize) {
		td.setAttribute("width", parseInt(resize)+"px");
		td.style.width = parseInt(resize)+"px";
	}
	else
		td.setAttribute("width", "200px");

	td.setAttribute("align", "right");	
	td.onclick = function(){alternate_border(ID);resizeWindow()}; 
	td.setAttribute("noWrap","true");
        td.alt = borderTitle;
        td.title = borderTitle;
	borderTitle = borderTitle ?  borderTitle : id_value ? get_lang("No Subject") : "&nbsp;"	;
	td.value = borderTitle;
	if (borderTitle.length > 21)
		borderTitle = borderTitle.substring(0,21) + "...";

	if (resize)
		borderTitle = borderTitle.substring(0, resize*0.08);

	td.innerHTML = "<table width=100% border=0 cellspacing=0 cellpadding=0><tr><td id=font_border_id_" + ID+" class='font-menu' width=*>" + borderTitle + "</td><td width=1px><img onmousedown='javascript:return false' style='cursor:pointer' onclick=delete_border('" + ID + "','false') src='"+URL_SERVER+"expressoMail1_2/templates/"+template+"/images/close_button.gif'></td></tr></table>";

	bb = document.getElementById("border_blank");
	parent_bb = bb.parentNode; //Pego o tbody
	parent_bb.insertBefore(td, bb);

	if(! Element("border_id_"+id_value+"_r") ||((typeof(id_value) == 'string') && id_value.match(/_r$/)))
		_dragArea.makeDragged(td, id_value,td.value);

	BordersArray[BordersArray.length] = new setBorderAttributes(ID);

	var div = document.createElement("DIV");
	div.id = "content_id_" + ID;
	div.className = "conteudo";
	div.style.display='';

	div.style.overflow = "hidden";
	Element("exmail_main_body").insertBefore(div,Element("footer_menu"));
	alternate_border(ID);
	return ID;
}

function resize_borders()
{
	var children;
	var	numBorders = 0;	
	var widthTD = 0;
	var newWidthTD = 0;		
	children = Element('border_tr').childNodes;	
	for (var i=0; i<children.length; i++) {
		if ((children[i].nodeName === 'TD') && (children[i].id!=='border_id_0') && (children[i].id!=='border_blank')) {
			numBorders++;
			if(!widthTD)
				widthTD = children[i].clientWidth;				
		}
	}
	if (numBorders > 8)
		return false;
	
	newWidthTD = ((numBorders*widthTD)+(Element("border_blank").clientWidth-44))/(numBorders+1);
	for (var i=0; i<children.length; i++) {
		if ((children[i].nodeName === 'TD') && (children[i].id!=='border_id_0') && (children[i].id!=='border_blank')){
			children[i].style.width = newWidthTD;
			Element("font_"+children[i].id).innerHTML = Element("font_"+children[i].id).innerHTML.substring(0, newWidthTD*0.08);
		}
	}
	return newWidthTD;
}

function delete_border(ID, msg_sent)
{
	var borderElem = Element("border_id_" + ID);
	if (borderElem)
		borderElem.onclick = null; // It's avoid a FF3 bug
	else
		return false;

	if (msg_sent == 'false')
	{
		var body = document.getElementById('body_'+ ID);
		if (body)
		{
				var save_link = Element("save_message_options_"+ID);
				if (openTab.toPreserve[ID] == undefined);
					openTab.toPreserve[ID] = false;
				if ((! openTab.toPreserve[ID] && ! ID.toString().match("_r")) || ((body.contentWindow) == 'object' && body.contentWindow.document.designMode.toLowerCase() == 'on') && (save_link.onclick != ''))
				{
					var discard_msg = confirm(get_lang("Your message has not been sent. Discard your message?"), "");
					if (!discard_msg)
					{
						Element("border_id_"+ID).onclick = function () { alternate_border(ID);};
						return;
					}
					else
					{
						if (openTab.imapBox[ID] &&  openTab.imapUid[ID] && !openTab.toPreserve[ID]){
							delete_msgs(openTab.imapBox[ID], openTab.imapUid[ID].toString(), 0);
							openTab.toPreserve[ID] = false;
							}
						delete(openTab.imapBox[ID]);	
							// Element('to_'+ID).focus(); It crash on IE
					}
				}
		}
	}

	openTab.toPreserve[ID] = false;
	openTab.imapUid[ID] = 0;

	if (preferences.auto_save_draft == 1)
	{
		if (openTab.autosave_timer[ID])
			clearTimeout(openTab.autosave_timer[ID]);
		openTab.autosave_timer[ID] = false;
	}

	expresso.connector.hold_session = false;
	if (exist_className(Element('border_id_'+ID),'menu-sel'))
	{
		if (BordersArray[BordersArray.length-2].sequence == ID)
			this.alternate_border(0);
		else
			this.alternate_border(BordersArray[BordersArray.length-2].sequence);
	}

	// Remove TD, title
	border = Element('border_id_' + ID);
	border.parentNode.removeChild(border);
	var j=0;
	var new_BordersArray = new Array();
	for (i=0;i<BordersArray.length;i++)
		if (document.getElementById(BordersArray[i].border_id) != null){
			new_BordersArray[j] = BordersArray[i];
			j++;
		}
	if(j == 1)
		Element("footer_menu").style.display = '';
	BordersArray = new_BordersArray;

	// Remove Div Content
	content = Element('content_id_' + ID);
	content.parentNode.removeChild(content);
	resizeWindow();
	return true;
};
